// SFB Program
// Started 3/7/98

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <allegro.h>
#include <random.h>
#include <time.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include "sfb.h"

#define rnd(x) (random() % x)
#define rnd2(x) (rnd(x) + 1)
#define msgbox(x) alert(x, NULL, NULL, "OK", NULL, KEY_ENTER, 0)

#define BS 256
#define ABRVS 5
#define N_SYS 31
#define MAX_WEAPONS 20
#define MAX_SHIPS 256
#define MAX_UNITS 256
#define MAX_ALLOC 100
#define MAX_BUTTONS 20
#define MAX_DIALOG 200
#define MAX_FIELD 50
#define COL_BUF 300
#define EBOX_SIZE 10
#define TEXT_W 8
#define TEXT_H 8
#define MAX_RANGE 20
#define TURN_INC 21
#define TURN_MAX 43
#define SCROLL_INC 10
#define MAX_BANK 10
#define LINE_INC 3
#define PARSEC 64
#define MAX_LOG 256
#define LOG_ROWS 7
#define PROJ_SPEED 8

#define MARGIN_LEFT 10
#define MARGIN_RIGHT 10
#define MARGIN_TOP 10
#define MARGIN_BOTTOM 10

#define FONT_SZ 8
#define FONT_BUF 10
#define FONT_PAD 1
#define BUTTON_BUF 5
#define MAX_TRACK 10

#define wp_Phaser 0
#define wp_Disruptor 1
#define wp_Photon 2
#define wp_ADD 3
#define wp_Drone 4
#define wp_Plasma 5
#define wp_Any 3

char *wtypes[] = {"Phaser", "Disruptor", "Photon torpedo", "Anti-drone defense", "Drone launcher", "Plasma torpedo launcher"};

char *wstypes[10];
int n_wstypes;

char *sysname[] = {
	"Shield #1:",
	"Shield #2:",
	"Shield #3:",
	"Shield #4:",
	"Shield #5:",
	"Shield #6:",
	"Left warp:",
	"Right warp:",
	"Center warp:",
	"Impulse engines:",
	"Reactors:",
	"Batteries:",
	"Bridge:",
	"Security:",
	"Flag bridge:",
	"Emergency bridge:",
	"Auxiliary control:",
	"Lab:",
	"Forward hull:",
	"Aft hull:",
	"Center hull:",
	"Cargo:",
	"Tractor beams:",
	"Transporters:",
	"Shuttle bays:",
	"Crew:",
	"Boarding parties:",
	"Probe:",
	"Cloaking device:",
	"Web spinner:",
	"Excess damage:"
	};

#define sys_Shield1 0
#define sys_Shield2 1
#define sys_Shield3 2
#define sys_Shield4 3
#define sys_Shield5 4
#define sys_Shield6 5
#define sys_LeftWarp 6
#define sys_RightWarp 7
#define sys_CenterWarp 8
#define sys_Impulse 9
#define sys_Reactor 10
#define sys_Batteries 11
#define sys_Bridge 12
#define sys_Security 13
#define sys_FlagBridge 14
#define sys_EmergBridge 15
#define sys_AuxControl 16
#define sys_Lab 17
#define sys_FHull 18
#define sys_AHull 19
#define sys_CHull 20
#define sys_Cargo 21
#define sys_Tractor 22
#define sys_Trans 23
#define sys_Shuttle 24
#define sys_Crew 25
#define sys_BoardP 26
#define sys_Probe 27
#define sys_Cloak 28
#define sys_Web 29
#define sys_Excess 30
#define sys_Sensor 31
#define sys_Scanner 32
#define sys_DamCon 33
#define sys_AnyWarp 34

typedef struct ranget {
	unsigned char r, c;
	} ranget;

typedef struct phasert {
	unsigned char *name, size;
	float cost;
	ranget range[6][11];
	} phasert;

typedef struct addt {
	unsigned char *name, mags, num;
	} addt;

typedef struct dronert {
	unsigned char *name, mags, spaces, rate;
	} dronert;

typedef struct dronet {
	unsigned char *name, speed, endurance, warhead, damage;
	float spaces;
	} dronet;

typedef struct plasmat {
	unsigned char *name, cost[3], hold, max_range;
	ranget range[7];
	} plasmat;

phasert phaser[] = {
	{"Type I phaser", 3, 1, {
		{{0, 9}, {1, 8}, {2, 7}, {3, 6}, {5, 5}, {8, 4}, {15, 3}, {25, 2}, {75, 1}},
		{{0, 8}, {1, 7}, {2, 6}, {4, 5}, {5, 4}, {8, 3}, {15, 2}, {50, 1}},
		{{0, 7}, {2, 5}, {5, 4}, {8, 3}, {15, 1}},
		{{0, 6}, {4, 4}, {5, 3}, {8, 2}},
		{{0, 5}, {3, 4}, {5, 3}, {8, 1}},
		{{1, 4}, {3, 3}, {5, 2}}
		}},
	{"Type II phaser", 2, 1, {
		{{0, 6}, {2, 5}, {3, 4}, {8, 3}, {15, 2}, {50, 1}},
		{{0, 6}, {1, 5}, {3, 4}, {8, 2}, {30, 1}},
		{{0, 6}, {3, 4}, {15, 1}},
		{{0, 5}, {2, 4}, {3, 3}, {8, 1}},
		{{0, 5}, {1, 4}, {3, 3}},
		{{0, 5}, {3, 3}}
		}},
	{"Type III phaser", 1, 0.5, {
		{{2, 4}, {3, 3}, {15, 1}},
		{{2, 4}, {3, 2}, {8, 1}},
		{{2, 4}, {3, 1}},
		{{1, 4}, {2, 3}},
		{{0, 4}, {1, 3}, {2, 2}},
		{{1, 3}, {2, 1}}
		}},
	{"Type IV phaser", 4, 2, {
		{{6, 20}, {7, 15}, {8, 12}, {9, 10}, {10, 8}, {13, 6}, {17, 5}, {25, 4}, {40, 3}, {70, 2}, {100, 1}},
		{{5, 20}, {6, 15}, {7, 12}, {8, 11}, {9, 9}, {10, 8}, {13, 6}, {17, 4}, {25, 3}, {40, 2}, {70, 1}},
		{{3, 20}, {5, 15}, {6, 12}, {7, 11}, {8, 10}, {9, 8}, {10, 7}, {13, 5}, {17, 4}, {25, 2}, {40, 1}},
		{{3, 20}, {5, 15}, {6, 11}, {7, 10}, {8, 9}, {9, 8}, {10, 6}, {13, 4}, {17, 3}, {25, 1}},
		{{3, 15}, {5, 12}, {6, 10}, {7, 9}, {8, 8}, {9, 7}, {10, 5}, {13, 3}, {17, 2}},
		{{3, 15}, {5, 10}, {6, 9}, {7, 8}, {8, 7}, {9, 6}, {10, 5}, {13, 3}, {17, 1}}
		}},
	{"Gatling phaser", 1, 0.25, {
		{{2, 4}, {3, 3}, {15, 1}},
		{{2, 4}, {3, 2}, {8, 1}},
		{{2, 4}, {3, 1}},
		{{1, 4}, {2, 3}},
		{{0, 4}, {1, 3}, {2, 2}},
		{{1, 3}, {2, 1}}
		}}
	};
addt add[] = {
	{"Anti-drone defense-6", 1, 6},
	{"Anti-drone defense-12", 1, 6},
	{"Anti-drone defense-30", 5, 6}
	};
dronert droner[] = {
	{"Type-A drone rack", 1, 4, 1},
	{"Type-B drone rack", 1, 6, 1},
	{"Type-C drone rack", 1, 4, 2},
	{"Type-D drone rack", 3, 4, 1},
	{"Type-E drone rack", 1, 4, 4},
	{"Type-F drone rack", 1, 4, 1},
	{"Type-G drone/anti-drone rack", 1, 4, 1}
	};
dronet drone[] = {
	{"Type-I drone", 8, 3, 12, 4, 1},
	{"Type-II drone", 12, 2, 12, 4, 1},
	{"Type-III drone", 12, 25, 12, 4, 1},
	{"Type-IV drone", 8, 3, 24, 6, 2},
	{"Type-V drone", 12, 2, 24, 6, 2},
	{"Type-VI dogfight drone", 12, 1, 8, 3, 0.5}
	};
plasmat plasma[] = {
	{"Type-R plasma torpedo", {2, 2, 5}, 4, 30, {{10, 50}, {15, 35}, {20, 25}, {25, 20}, {28, 10}, {29, 5}, {30, 1}}},
	{"Type-S plasma torpedo", {2, 2, 4}, 2, 25, {{10, 30}, {15, 22}, {20, 15}, {23, 10}, {24, 5}, {25, 1}}},
	{"Type-G plasma torpedo", {2, 2, 3}, 1, 20, {{10, 20}, {15, 15}, {18, 10}, {19, 5}, {20, 1}}},
	{"Type-F plasma torpedo", {1, 1, 3}, 0, 15, {{5, 20}, {10, 15}, {12, 10}, {14, 5}, {15, 1}}}
	};
ranget photon[] = {{1, 0}, {2, 5}, {4, 4}, {8, 3}, {12, 2}, {30, 1}};
ranget photon_prox[] = {{8, 0}, {12, 4}, {30, 3}};
ranget photon_oload[] = {{1, 6}, {2, 5}, {4, 4}, {8, 3}};
ranget disrupt[] = {{0, 0}, {2, 5}, {15, 4}, {22, 3}, {40, 2}};
ranget disrupt_uim[] = {{0, 0}, {2, 5}, {22, 4}, {40, 2}};
ranget disrupt_derfacs[] = {{0, 0}, {2, 5}, {15, 4}, {30, 3}, {40, 2}};
ranget disrupt_oload[] = {{0, 6}, {2, 5}, {8, 4}};
ranget disrupt_oload_uim[] = {{0, 6}, {8, 5}};
ranget ddamage[] = {{0, 0}, {1, 5}, {4, 4}, {15, 3}, {30, 2}, {40, 1}};
ranget ddamage_oload[] = {{1, 10}, {4, 8}, {8, 6}};
ranget add_table[] = {{0, 0}, {1, 2}, {2, 3}, {3, 4}};
ranget turnm[6][8] = {
	{{8, 1}, {16, 2}, {24, 3}, {32, 4}},
	{{6, 1}, {12, 2}, {19, 3}, {26, 4}, {32, 5}},
	{{5, 1}, {10, 2}, {15, 3}, {21, 4}, {28, 5}, {32, 6}},
	{{4, 1}, {9, 2}, {14, 3}, {20, 4}, {27, 5}, {32, 6}},
	{{3, 1}, {6, 2}, {10, 3}, {14, 4}, {20, 5}, {29, 6}, {32, 7}},
	{{3, 1}, {5, 2}, {9, 3}, {13, 4}, {17, 5}, {23, 6}, {29, 7}, {32, 8}}
	};

short dmgalloc[11][13] = {
	{sys_Bridge, sys_FlagBridge, sys_Sensor, sys_DamCon, sys_AHull, sys_LeftWarp, sys_Trans, sys_Tractor, sys_Shuttle, sys_Lab, sys_FHull, sys_RightWarp, sys_Excess},
	{wp_Drone, wp_Phaser, sys_Impulse, sys_LeftWarp, sys_RightWarp, sys_AHull, sys_Shuttle, sys_DamCon, sys_CenterWarp, sys_Lab, sys_Batteries, wp_Phaser, sys_Excess},
	{wp_Phaser, sys_Trans, sys_RightWarp, sys_Impulse, sys_FHull, sys_AHull, sys_LeftWarp, sys_Reactor, sys_Lab, sys_Trans, sys_Probe, sys_CenterWarp, sys_Excess},
	{sys_RightWarp, sys_AHull, sys_Cargo, sys_Batteries, sys_Shuttle, wp_Photon, sys_LeftWarp, sys_Impulse, sys_RightWarp, sys_Tractor, sys_Probe, wp_Any, sys_Excess},
	{sys_FHull, sys_Impulse, sys_Lab, sys_LeftWarp, sys_Sensor, sys_Tractor, sys_Shuttle, sys_RightWarp, wp_Phaser, sys_Trans, sys_Batteries, wp_Any, sys_Excess},
	{sys_Cargo, sys_FHull, sys_Batteries, sys_CenterWarp, sys_Shuttle, sys_Reactor, sys_Lab, wp_Phaser, sys_AnyWarp, sys_Probe, sys_AHull, wp_Any, sys_Excess},
	{sys_AHull, sys_Reactor, sys_Shuttle, sys_RightWarp, sys_Scanner, sys_Tractor, sys_Lab, sys_LeftWarp, wp_Phaser, sys_Trans, sys_Batteries, wp_Any, sys_Excess},
	{sys_LeftWarp, sys_FHull, sys_Cargo, sys_Batteries, sys_Lab, wp_Drone, sys_RightWarp, sys_Impulse, sys_LeftWarp, sys_Tractor, sys_Probe, wp_Any, sys_Excess},
	{wp_Phaser, sys_Tractor, sys_LeftWarp, sys_Impulse, sys_AHull, sys_FHull, sys_Tractor, sys_DamCon, sys_CenterWarp, sys_Lab, sys_Batteries, wp_Phaser, sys_Excess},
	{sys_AuxControl, sys_EmergBridge, sys_Scanner, sys_Probe, sys_FHull, sys_RightWarp, sys_Trans, sys_Shuttle, sys_Tractor, sys_Lab, sys_AHull, sys_LeftWarp, sys_Excess}
	};

char lockloc[][2] = {{0, 0}, {0, 1}, {0, 2}, {0, 3}, {0, 4}, {1, 0}, {1, 1}, {1, 7}, {2, 0}, {2, 1}, {3, 0}, {3, 5}, {4, 4}, {6, 4}, {7, 0}, {7, 5}, {8, 0}, {8, 1}, {9, 0}, {9, 1}, {9, 7}, {10, 0}, {10, 1}, {10, 2}, {10, 3}, {10, 4}};

typedef struct weapont {
	fixed min, max;
	unsigned char num, type, subtype, arcdesc[10];
	} weapont;

typedef struct typet {
	unsigned char name[BS], abbrev[ABRVS], race[BS], size, breakdown, turn_mode, n_weapons;
	unsigned char sensor[MAX_TRACK], n_sensor, scanner[MAX_TRACK], n_scanner;
	unsigned char damcon[MAX_TRACK], n_damcon, cloakcost;
	unsigned short bpv_eco, bpv_combat, min_crew;
	float shield_min, shield_full, lifesup, mcost;
	unsigned short sys[N_SYS];
	weapont weapon[MAX_WEAPONS];
	BITMAP *icon;
	} typet;

typedef struct weapstatt {
	unsigned char num;
	short power, used, armed, targ[MAX_UNITS];
	} weapstatt;

typedef struct unitt {
	unsigned char name[BS], ws, sensor, scanner, damcon, ppt, tmode, speed, team, con, skip;
	unsigned char last_turn;
	unsigned short sys[N_SYS], syspower[N_SYS], fcontrol, shields, gen_reinforce;
	unsigned short reinforce[6], move, het, erratic, dmgcon, recharge, tractor, trans, ecm, eccm;
	unsigned short cloakpower, web, pcap, pcap_max, crewd, bpartyd;
	short xs, ys;
	int x, y, t;
	fixed r;
	weapstatt weapstat[MAX_WEAPONS];
	} unitt;

typedef struct alloct {
	unsigned char desc[BS];
	unsigned short *cur, max, inc;
	} alloct;

typedef struct statt {
	unsigned char desc[BS];
	unsigned short cur, max, pc;
	} statt;

typedef struct buttont {
	BITMAP *icon;
	unsigned char state, tag;
	} buttont;

typet type[MAX_SHIPS];
unitt unit[MAX_UNITS];
buttont *bmenu, bmain[MAX_BUTTONS], bdone[MAX_BUTTONS], bturn[MAX_BUTTONS];
buttont bgame[MAX_BUTTONS], bweapons[MAX_BUTTONS], bgame[MAX_BUTTONS];
unsigned char bmain_n, bdone_n, bturn_n, bgame_n, bweapons_n, num[BS], min[BS], max[BS];
unsigned char bgame_n;
unsigned short n_types = 0, n_units = 0, turn = 0, imp = 0, cu, acnt = 0;
unsigned char click_speed = 5, ccl = 0, ccr = 0, n_buttons = 0, wd[MAX_WEAPONS][BS];
unsigned short anim_speed = 0, logc = 0, logw = 0;
unsigned char dirty = 1, bdown = 0, logs[MAX_LOG][BS];
DIALOG d_type_edit[MAX_DIALOG];
int xw = 0, yw = 0, scen_w = 1000, scen_h = 1000, ax1, ay1, ax2, ay2;
time_t now;
DATAFILE *df;

int black, white, yellow, red, green, blue;
unsigned char soundf = 1, quit;

BITMAP *buffer, *bg, *map, *toolbar, *display, *status, *disp_bmp, *metal, *logo, *whole_map, *old;
BITMAP *icon_done, *icon_reset, *icon_tedit, *icon_tnew, *icon_game, *icon_weapons, *icon_play;
BITMAP *icon_turn, *icon_photon, *icon_status, *icon_skip, *icon_quit;
typet *_ctype = NULL;

int draw_buttons();
void draw_status();
char check_arc(int a, int t, fixed min, fixed max);

void init_bmp(BITMAP *bmp) {
set_clip(bmp, 0, 0, bmp->w, bmp->h);
}

int _radius = 1;

void _circle(BITMAP *bmp, int x, int y, int c) {
circle(bmp, x, y, _radius, c);
}

unsigned char isint(char *str) {

int c = 0;

while (str[c])
	if (!isdigit(str[c++]))
		return 0;
return 1;

}

void write_log(char *str) {

if (++logc >= MAX_LOG) {
	logc = MAX_LOG-1;
	memcpy(logs[0], logs[1], (MAX_LOG-1) * BS);
	}
if (str)
	strcpy(logs[logc], str);
else
	logs[logc][0] = '\0';
if (logw == logc - LOG_ROWS) ++logw;

}

void patfill(BITMAP *targ, BITMAP *pat, int x, int y) {

int j, k, xs = targ->w / pat->w, ys = targ->h / pat->h;

x %= pat->w;
y %= pat->h;

for (j = 0; j <= xs; ++j)
	for (k = 0; k <= ys; ++k)
		blit(pat, targ, 0, 0, j * pat->w - x, k * pat->h - y, pat->w, pat->h);

}

int dist2d(int x1, int y1, int x2, int y2) {
return (int)sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
}

int get_dist(int a, int t) {

int ret = dist2d(unit[a].x, unit[a].y, unit[t].x, unit[t].y) / PARSEC, ew = unit[a].ecm - unit[t].eccm;
if (ew > 0) ret += ew;
return ret;

}


unsigned char get_range(ranget *r, unsigned char n) {

int j;

for (j = 0; j < MAX_RANGE; ++j)
	if (n <= r[j].r)
		return r[j].c;
return 0;

}

unsigned char mouse_left() {

if (mouse_b & 1) {
	if (++ccl == click_speed) {
		ccl = 0;
		return 1;
		}
	}
else
	ccl = 0;
return 0;

}

unsigned char mouse_right() {

if (mouse_b & 2) {
	if (++ccr == click_speed) {
		ccr = 0;
		return 1;
		}
	}
else
	ccr = 0;
return 0;

}

void set_menu(buttont *nmenu, int nsize) {

bmenu = nmenu;
n_buttons = nsize;
draw_buttons();

}

void init_menu(buttont *nmenu, int nsize) {

int j;

for (j = 0; j < n_buttons; ++j)
	bmenu[j].state = 0;
dirty = 1;
set_menu(nmenu, nsize);

}

int text_right(int x, char *str) {
return x - text_length(font, str);
}

void check_scroll() {

if (key[KEY_LEFT]) {
	xw -= SCROLL_INC;
	if (xw < 0) xw = 0;
	dirty = 1;
	}
if (key[KEY_RIGHT]) {
	xw += SCROLL_INC;
	if (xw > scen_w - 700) xw = scen_w - 700;
	dirty = 1;
	}
if (key[KEY_UP]) {
	yw -= SCROLL_INC;
	if (yw < 0) yw = 0;
	dirty = 1;
	}
if (key[KEY_DOWN]) {
	yw += SCROLL_INC;
	if (yw > scen_h - 500) yw = scen_h - 500;
	dirty = 1;
	}

}

void center_map(int x, int y) {

if (x < 700)
	xw = 0;
else if (x > scen_w - 700)
	xw = scen_w - 700;
else
	xw = x - 350;


if (y < 500)
	yw = 0;
else if (y > scen_h - 500)
	yw = scen_w - 500;
else
	yw = x - 250;

}

void load_type(typet *tp, char *path) {

int j;
char *mem = (char *)tp;
PACKFILE *f;

f = pack_fopen(path, "prb");
for (j = 0; j < sizeof(typet); ++j)
	mem[j] = pack_getc(f);
pack_fclose(f);

}

void save_type(typet *tp, char *path) {

int j;
char *mem = (char *)tp;
PACKFILE *f;

f = pack_fopen(path, "pwb");
for (j = 0; j < sizeof(typet); ++j)
	pack_putc(mem[j], f);
pack_fclose(f);

}

int draw_buttons() {

int cp = BUTTON_BUF, j, ret = -1;
char ml = mouse_b & 1;

patfill(toolbar, metal, 0, 0);
for (j = 0; j < n_buttons; ++j) {
	if (ml && !bdown && mouse_x >= 700 + BUTTON_BUF && mouse_x <= 700 + BUTTON_BUF + bmenu[j].icon->w && mouse_y >= cp && mouse_y <= cp + bmenu[j].icon->h && !bmenu[j].state) {
		bmenu[j].state = 1;
		dirty = 1;
		bdown = 1;
		}
	else if (bmenu[j].state && !ml) {
		bmenu[j].state = 0;
		dirty = 1;
		bdown = 0;
		if (mouse_x >= 700 + BUTTON_BUF && mouse_x <= 700 + BUTTON_BUF + bmenu[j].icon->w && mouse_y >= cp && mouse_y <= cp + bmenu[j].icon->h)
			ret = bmenu[j].tag;
		}
	if (bmenu[j].state) {
		rectfill(toolbar, BUTTON_BUF, cp, BUTTON_BUF + bmenu[j].icon->w, cp + bmenu[j].icon->h, red);
		blit(bmenu[j].icon, toolbar, 1, 1, BUTTON_BUF, cp, bmenu[j].icon->w - 2, bmenu[j].icon->h - 2);
		}
	else
		blit(bmenu[j].icon, toolbar, 0, 0, BUTTON_BUF, cp, bmenu[j].icon->w, bmenu[j].icon->h);
	cp += BUTTON_BUF + bmenu[j].icon->h;
	}

return ret;

}

char *weapdesc(char *str, weapont *w) {

switch (w->type) {
	case wp_Phaser:
		sprintf(str, "%s %s", phaser[w->subtype].name, w->arcdesc);
		break;
	case wp_Disruptor:
		sprintf(str, "Disruptor %s", w->arcdesc);
		break;
	case wp_Photon:
		sprintf(str, "Photon torpedo %s", w->arcdesc);
		break;
	case wp_Plasma:
		sprintf(str, "%s %s", plasma[w->subtype].name, w->arcdesc);
		break;
	case wp_Drone:
		sprintf(str, "%s", droner[w->subtype].name);
		break;
	case wp_ADD:
		sprintf(str, "Anti-drone defense");
		break;
	}

return str;

}

void show_status(unitt *u) {

int n_stat = 0, j, k;
statt stat[MAX_ALLOC];
char done = 0, temp[BS];

for (j = 0; j < N_SYS; ++j) {
	if (type[u->t].sys[j]) {
		stat[n_stat].cur = u->sys[j];
		stat[n_stat].max = type[u->t].sys[j];
		stat[n_stat].pc = (float)(stat[n_stat].cur) / (float)(stat[n_stat].max) * 100;
		strcpy(stat[n_stat++].desc, sysname[j]);
		}
	}
for (j = 0; j < type[u->t].n_weapons; ++j) {
	stat[n_stat].cur = u->weapstat[j].num;
	stat[n_stat].max = type[u->t].weapon[j].num;
	stat[n_stat].pc = (float)(stat[n_stat].cur) / (float)(stat[n_stat].max) * 100;
	weapdesc(stat[n_stat++].desc, &(type[u->t].weapon[j]));
	}

init_menu(bdone, bdone_n);

dirty = 1;
while (!done) {
	patfill(toolbar, metal, 0, 0);
	switch (draw_buttons()) {
		case 0:
			done = 1;
			break;
		}
	if (dirty) {
		draw_status();
		clear_to_color(map, white);
		rect(map, 0, 0, 700, FONT_BUF, black);
		textout(map, font, "System", 1, 1, blue);
		textout(map, font, "Number", 520, 1, red);
		textout(map, font, "Max", 580, 1, red);
		textout(map, font, "Percent", 640, 1, red);
		vline(map, 520, 0, FONT_BUF, black);
		vline(map, 580, 0, FONT_BUF, black);
		vline(map, 640, 0, FONT_BUF, black);

		for (j = 0; j < n_stat; ++j) {
			rect(map, 0, (j+1) * FONT_BUF, 700, (j+2) * FONT_BUF, black);
			textout(map, font, stat[j].desc, 1 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			textout(map, font, itoa(stat[j].cur, temp, 10), 520 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			textout(map, font, itoa(stat[j].max, temp, 10), 580 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			textout(map, font, itoa(stat[j].pc, temp, 10), 640 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			vline(map, 520, (j+1) * FONT_PAD, (j+2) * FONT_BUF, black);
			vline(map, 580, (j+1) * FONT_PAD, (j+2) * FONT_BUF, black);
			vline(map, 640, (j+1) * FONT_PAD, (j+2) * FONT_BUF, black);
			}

		vsync();
		show_mouse(NULL);
		blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		show_mouse(screen);
		dirty = 0;
		}
	}
dirty = 1;

}

void set_weapon() {

_ctype->weapon[d_type_edit[1].d1].type = d_type_edit[2].d1;
_ctype->weapon[d_type_edit[1].d1].subtype = d_type_edit[3].d1;
_ctype->weapon[d_type_edit[1].d1].num = atoi(num);
_ctype->weapon[d_type_edit[1].d1].min = itofix(atoi(min));
_ctype->weapon[d_type_edit[1].d1].max = itofix(atoi(max));

}

void update_weapon() {

int j;

for (j = 0; j < _ctype->n_weapons; ++j)
	weapdesc(wd[j], &(_ctype->weapon[j]));

d_type_edit[2].d1 = _ctype->weapon[d_type_edit[1].d1].type;
switch (_ctype->weapon[d_type_edit[1].d1].type) {
	case wp_Phaser:
		n_wstypes = 5;
		for (j = 0; j < 5; ++j)
			wstypes[j] = phaser[j].name;
		break;
	case wp_Drone:
		n_wstypes = 6;
		for (j = 0; j < 6; ++j)
			wstypes[j] = droner[j].name;
		break;
	case wp_Plasma:
		n_wstypes = 4;
		for (j = 0; j < 4; ++j)
			wstypes[j] = plasma[j].name;
		break;
	default:
		n_wstypes = 0;
	}
d_type_edit[3].d1 = _ctype->weapon[d_type_edit[1].d1].subtype;
d_type_edit[11].dp = _ctype-> weapon[d_type_edit[1].d1].arcdesc;
itoa(_ctype->weapon[d_type_edit[1].d1].num, num, 10);
itoa(fixtoi(_ctype->weapon[d_type_edit[1].d1].min), min, 10);
itoa(fixtoi(_ctype->weapon[d_type_edit[1].d1].max), max, 10);
broadcast_dialog_message(MSG_DRAW, 0);

}

char *fill_subtypes(int index, int *list_size) {

if (index < 0) {
	*list_size = n_wstypes;
	return NULL;
	}

return wstypes[index];

}

char *fill_weapons(int index, int *list_size) {

if (index < 0) {
	*list_size = _ctype->n_weapons;
	return NULL;
	}

return wd[index];

}

int d_weaplist_proc(int msg, DIALOG *d, int c) {

if (msg == MSG_CLICK)
	set_weapon();
d_list_proc(msg, d, c);
if (msg == MSG_CLICK) {
	update_weapon();
	}

}

char *fill_wtypes(int index, int *list_size) {

if (index < 0) {
	*list_size = 6;
	return NULL;
	}

return wtypes[index];

}

int d_wtlist_proc(int msg, DIALOG *d, int c) {

d_list_proc(msg, d, c);
if (msg == MSG_CLICK) {
	_ctype->weapon[d_type_edit[1].d1].type = d->d1;
	update_weapon();
	}

}

int d_badd_proc(int msg, DIALOG *d, int c) {

d_button_proc(msg, d, c);
if (msg == MSG_CLICK) {
	d->flags ^= D_SELECTED;
	bzero(&(_ctype->weapon[(_ctype->n_weapons)++]), sizeof(weapont));
	update_weapon();
	}

}

int d_bdel_proc(int msg, DIALOG *d, int c) {

int j;

d_button_proc(msg, d, c);
if (msg == MSG_CLICK) {
	d->flags ^= D_SELECTED;
	for (j = d_type_edit[1].d1; j < _ctype->n_weapons - 1; ++j)
		memcpy(&(_ctype->weapon[j]), &(_ctype->weapon[j+1]), sizeof(weapont));
	--(_ctype->n_weapons);
	update_weapon();
	}

}

void edit_type(typet *tp) {

unsigned char *desc[MAX_FIELD], *buf[MAX_FIELD], stat = 1, sysbuf[N_SYS][BS], temp[BS];
int n_field = 11, j, dc = 14;
unsigned char breakdown[BS], size[BS], cloak[BS], turn[BS], move[BS], sensor[BS], scanner[BS];
unsigned char damcon[BS], *t;

_ctype = tp;
itoa(tp->breakdown, breakdown, 10);
itoa(tp->size, size, 10);
itoa(tp->cloakcost, cloak, 10);
turn[0] = tp->turn_mode;
turn[1] = '\0';
sprintf(move, "%-f", (float)(tp->mcost));
itoa(tp->sensor[0], sensor, 10);
for (j = 1; j < tp->n_sensor; ++j)
	strcat(strcat(sensor, " "), itoa(tp->sensor[j], temp, 10));
itoa(tp->scanner[0], scanner, 10);
for (j = 1; j < tp->n_scanner; ++j)
	strcat(strcat(scanner, " "), itoa(tp->scanner[j], temp, 10));
itoa(tp->damcon[0], damcon, 10);
for (j = 1; j < tp->n_damcon; ++j)
	strcat(strcat(damcon, " "), itoa(tp->damcon[j], temp, 10));
for (j = 0; j < N_SYS; ++j)
	itoa(tp->sys[j], sysbuf[j], 10);

desc[0] = "Name:";
buf[0] = tp->name;
desc[1] = "Abbreviation:";
buf[1] = tp->abbrev;
desc[2] = "Race:";
buf[2] = tp->race;
desc[3] = "Breakdown:";
buf[3] = breakdown;
desc[4] = "Size class:";
buf[4] = size;
desc[5] = "Cloak cost:";
buf[5] = cloak;
desc[6] = "Turn mode:";
buf[6] = turn;
desc[7] = "Movement cost:";
buf[7] = move;
desc[8] = "Sensor track:";
buf[8] = sensor;
desc[9] = "Scanner track:";
buf[9] = scanner;
desc[10] = "Damage control track:";
buf[10] = damcon;
for (j = 0; j < N_SYS; ++j) {
	desc[n_field] = sysname[j];
	buf[n_field++] = sysbuf[j];
	}

bzero(d_type_edit, sizeof(DIALOG) * MAX_DIALOG);
d_type_edit[0].proc = d_shadow_box_proc;
d_type_edit[0].w = 700;
d_type_edit[0].h = 500;
d_type_edit[0].bg = white;
d_type_edit[0].fg = red;
d_type_edit[1].proc = d_weaplist_proc;
d_type_edit[1].dp = fill_weapons;
d_type_edit[1].x = MARGIN_LEFT;
d_type_edit[1].y = 500 - MARGIN_BOTTOM - TEXT_H * 2 - FONT_BUF * 7;
d_type_edit[1].w = TEXT_W * 32;
d_type_edit[1].h = FONT_BUF * 6;
d_type_edit[1].bg = blue;
d_type_edit[2].proc = d_wtlist_proc;
d_type_edit[2].dp = fill_wtypes;
d_type_edit[2].x = MARGIN_LEFT + TEXT_W * 32 + FONT_BUF;
d_type_edit[2].y = 500 - MARGIN_BOTTOM - TEXT_H * 2 - FONT_BUF * 7;
d_type_edit[2].w = TEXT_W * 25;
d_type_edit[2].h = FONT_BUF * 6;
d_type_edit[2].bg = blue;
d_type_edit[3].proc = d_list_proc;
d_type_edit[3].dp = fill_subtypes;
d_type_edit[3].x = MARGIN_LEFT + TEXT_W * 57 + FONT_BUF * 2;
d_type_edit[3].y = 500 - MARGIN_BOTTOM - TEXT_H * 2 - FONT_BUF * 7;
d_type_edit[3].w = TEXT_W * 25;
d_type_edit[3].h = FONT_BUF * 6;
d_type_edit[3].bg = blue;
d_type_edit[4].proc = d_button_proc;
d_type_edit[4].flags = D_EXIT;
d_type_edit[4].dp = "Done";
d_type_edit[4].x = MARGIN_LEFT;
d_type_edit[4].y = 500 - MARGIN_BOTTOM - TEXT_H * 2;
d_type_edit[4].w = text_length(font, d_type_edit[4].dp) + FONT_BUF;
d_type_edit[4].h = TEXT_H * 2;
d_type_edit[4].bg = green;
d_type_edit[5].proc = d_badd_proc;
d_type_edit[5].dp = "Add";
d_type_edit[5].x = d_type_edit[4].x + d_type_edit[4].w + FONT_BUF;
d_type_edit[5].y = 500 - MARGIN_BOTTOM - TEXT_H * 2;
d_type_edit[5].w = text_length(font, d_type_edit[5].dp) + FONT_BUF;
d_type_edit[5].h = TEXT_H * 2;
d_type_edit[5].bg = green;
d_type_edit[6].proc = d_bdel_proc;
d_type_edit[6].dp = "Remove";
d_type_edit[6].x = d_type_edit[5].x + d_type_edit[5].w + FONT_BUF;
d_type_edit[6].y = 500 - MARGIN_BOTTOM - TEXT_H * 2;
d_type_edit[6].w = text_length(font, d_type_edit[6].dp) + FONT_BUF;
d_type_edit[6].h = TEXT_H * 2;
d_type_edit[6].bg = green;
d_type_edit[7].proc = d_text_proc;
d_type_edit[7].dp = "Arc name:";
d_type_edit[7].x = MARGIN_LEFT;
d_type_edit[7].y = d_type_edit[1].y - FONT_BUF * 2;
d_type_edit[7].w = text_length(font, d_type_edit[7].dp);
d_type_edit[7].h = TEXT_H;
d_type_edit[7].bg = white;
d_type_edit[8].proc = d_text_proc;
d_type_edit[8].dp = "Count:";
d_type_edit[8].x = MARGIN_LEFT + (EBOX_SIZE+1) * TEXT_W + FONT_PAD;
d_type_edit[8].y = d_type_edit[7].y;
d_type_edit[8].w = text_length(font, d_type_edit[8].dp);
d_type_edit[8].h = TEXT_H;
d_type_edit[8].bg = white;
d_type_edit[9].proc = d_text_proc;
d_type_edit[9].dp = "Arc min:";
d_type_edit[9].x = MARGIN_LEFT + ((EBOX_SIZE+1) * TEXT_W  + FONT_PAD) * 2;
d_type_edit[9].y = d_type_edit[7].y;
d_type_edit[9].w = text_length(font, d_type_edit[9].dp);
d_type_edit[9].h = TEXT_H;
d_type_edit[9].bg = white;
d_type_edit[10].proc = d_text_proc;
d_type_edit[10].dp = "Arc max:";
d_type_edit[10].x = MARGIN_LEFT + ((EBOX_SIZE+1) * TEXT_W + FONT_PAD) * 3;
d_type_edit[10].y = d_type_edit[7].y;
d_type_edit[10].w = text_length(font, d_type_edit[8].dp);
d_type_edit[10].h = TEXT_H;
d_type_edit[10].bg = white;
d_type_edit[11].proc = d_edit_proc;
d_type_edit[11].d1 = 10;
d_type_edit[11].x = MARGIN_LEFT;
d_type_edit[11].y = d_type_edit[1].y - FONT_BUF;
d_type_edit[11].w = (EBOX_SIZE+1) * TEXT_W;
d_type_edit[11].h = TEXT_H;
d_type_edit[11].bg = blue;
d_type_edit[12].proc = d_edit_proc;
d_type_edit[12].dp = num;
d_type_edit[12].x = MARGIN_LEFT + (EBOX_SIZE+1) * TEXT_W + FONT_PAD;
d_type_edit[12].y = d_type_edit[11].y;
d_type_edit[12].w = (EBOX_SIZE+1) * TEXT_W;
d_type_edit[12].h = TEXT_H;
d_type_edit[12].d1 = BS;
d_type_edit[12].bg = blue;
d_type_edit[13].proc = d_edit_proc;
d_type_edit[13].dp = min;
d_type_edit[13].x = MARGIN_LEFT + ((EBOX_SIZE+1) * TEXT_W  + FONT_PAD) * 2;
d_type_edit[13].y = d_type_edit[11].y;
d_type_edit[13].w = (EBOX_SIZE+1) * TEXT_W;
d_type_edit[13].h = TEXT_H;
d_type_edit[13].d1 = BS;
d_type_edit[13].bg = blue;
d_type_edit[14].proc = d_edit_proc;
d_type_edit[14].dp = max;
d_type_edit[14].x = MARGIN_LEFT + ((EBOX_SIZE+1) * TEXT_W + FONT_PAD) * 3;
d_type_edit[14].y = d_type_edit[11].y;
d_type_edit[14].w = (EBOX_SIZE+1) * TEXT_W;
d_type_edit[14].h = TEXT_H;
d_type_edit[14].d1 = BS;
d_type_edit[14].bg = blue;

for (j = 0; j < n_field; ++j) {
	stat = !stat;
	d_type_edit[++dc].proc = d_text_proc;
	d_type_edit[dc].dp = desc[j];
	d_type_edit[dc].w =(EBOX_SIZE+1) * TEXT_W;
	d_type_edit[dc].h = TEXT_H;
	d_type_edit[dc].y = MARGIN_TOP + j / 2 * FONT_BUF;
	if (stat)
		d_type_edit[dc].x = text_right(700 - MARGIN_RIGHT - (EBOX_SIZE+1) * TEXT_W - FONT_PAD, desc[j]);
	else
		d_type_edit[dc].x = text_right(COL_BUF - (EBOX_SIZE+1) * TEXT_W - FONT_PAD, desc[j]);
	d_type_edit[dc].bg = white;
	d_type_edit[++dc].proc = d_edit_proc;
	d_type_edit[dc].dp = buf[j];
	d_type_edit[dc].w = (EBOX_SIZE+1) * TEXT_W;
	d_type_edit[dc].h = TEXT_H;
	d_type_edit[dc].y = MARGIN_TOP + j / 2 * FONT_BUF;
	if (stat)
		d_type_edit[dc].x = 700 - MARGIN_RIGHT - (EBOX_SIZE+1) * TEXT_W;
	else
		d_type_edit[dc].x = COL_BUF - (EBOX_SIZE+1) * TEXT_W;
	d_type_edit[dc].bg = blue;
	d_type_edit[dc].d1 = BS;
	}
update_weapon();

popup_dialog(d_type_edit, -1);
set_weapon();

tp->breakdown = atoi(breakdown);
tp->size = atoi(size);
tp->cloakcost = atoi(cloak);
tp->turn_mode = turn[0];
tp->mcost = atof(move);
tp->n_sensor = 0;
t = strtok(sensor, " ");
while (t) {
	tp->sensor[(tp->n_sensor)++] = atoi(t);
	t = strtok(NULL, " ");
	}
tp->n_scanner = 0;
t = strtok(scanner, " ");
while (t) {
	tp->scanner[(tp->n_scanner)++] = atoi(t);
	t = strtok(NULL, " ");
	}
tp->n_damcon = 0;
t = strtok(damcon, " ");
while (t) {
	tp->damcon[(tp->n_damcon)++] = atoi(t);
	t = strtok(NULL, " ");
	}
for (j = 0; j < N_SYS; ++j)
	if (isint(sysbuf[j]))
		tp->sys[j] =  atoi(sysbuf[j]);

}

void allocate_energy(int n) {

int n_alloc = 13, j, i;
alloct alloc[MAX_ALLOC];
char done = 0, temp[BS], np = 0;
unsigned short max_pwr = unit[n].sys[sys_LeftWarp] + unit[n].sys[sys_RightWarp] + unit[n].sys[sys_CenterWarp] + unit[n].sys[sys_Impulse] + unit[n].sys[sys_Reactor], pwr = max_pwr;
unsigned short pcap, ls;

bzero(alloc, sizeof(alloct) * MAX_ALLOC);
strcpy(alloc[0].desc, "Life support");
alloc[0].cur = &ls;
switch (type[unit[n].t].size) {
	case 1:
		alloc[0].max = 3;
		break;
	case 2:
		alloc[0].max = 2;
		break;
	default:
		alloc[0].max = 1;
	}
alloc[0].inc = alloc[0].max;

strcpy(alloc[1].desc, "Active fire control");
alloc[1].cur = &(unit[n].fcontrol);
alloc[1].max = 1;

strcpy(alloc[2].desc, "Activate shields");
switch (type[unit[n].t].size) {
	case 1:
		alloc[2].max = 7;
		break;
	case 2:
		alloc[2].max = 4;
		break;
	case 3:
		alloc[2].max = 2;
		break;
	default:
		alloc[2].max = 1;
	}
alloc[2].cur = &(unit[n].shields);

strcpy(alloc[3].desc, "General reinforcement");
alloc[3].cur = &(unit[n].gen_reinforce);

for (j = 1; j <= 6; ++j) {
	alloc[j+3].cur = &(unit[n].reinforce[j-1]);
	sprintf(alloc[j+3].desc, "Reinforce shield #%d", j);
	}

strcpy(alloc[10].desc, "Movement");
alloc[10].max = type[unit[n].t].mcost * 32;
alloc[10].cur = &(unit[n].move);

strcpy(alloc[11].desc, "High energy turn");
alloc[11].max = type[unit[n].t].mcost * 5;
alloc[11].cur = &(unit[n].het);

strcpy(alloc[12].desc, "Erratic maneuvering");
alloc[12].max = type[unit[n].t].mcost * 6;
alloc[12].cur = &(unit[n].erratic);

if (type[unit[n].t].damcon[unit[n].damcon]) {
	strcpy(alloc[n_alloc].desc, "Damage control");
	alloc[n_alloc].cur = &(unit[n].dmgcon);
	alloc[n_alloc++].max = type[unit[n].t].damcon[unit[n].damcon];
	}

if (unit[n].sys[sys_Batteries]) {
	strcpy(alloc[n_alloc].desc, "Recharge batteries");
	alloc[n_alloc].cur = &(unit[n].recharge);
	alloc[n_alloc++].max = unit[n].sys[sys_Batteries];
	}

if (unit[n].sys[sys_Tractor]) {
	alloc[n_alloc].cur = &(unit[n].tractor);
	strcpy(alloc[n_alloc++].desc, "Tractor/negative tractor beams");
	}

if (unit[n].sys[sys_Trans]) {
	strcpy(alloc[n_alloc].desc, "Transporters");
	alloc[n_alloc].cur = &(unit[n].trans);
	alloc[n_alloc++].max = unit[n].sys[sys_Trans] / 5;
	}

if (type[unit[n].t].sensor[unit[n].sensor]) {
	strcpy(alloc[n_alloc].desc, "Electronic counter measures");
	alloc[n_alloc].cur = &(unit[n].ecm);
	alloc[n_alloc++].max = type[unit[n].t].sensor[unit[n].sensor];
	strcpy(alloc[n_alloc].desc, "Electronic counter-counter measures");
	alloc[n_alloc].cur = &(unit[n].eccm);
	alloc[n_alloc++].max = type[unit[n].t].sensor[unit[n].sensor];
	}

if (unit[n].sys[sys_Cloak]) {
	strcpy(alloc[n_alloc].desc, "Cloaking device");
	alloc[n_alloc].cur = &(unit[n].cloakpower);
	alloc[n_alloc++].max = type[unit[n].t].cloakcost;
	}

if (unit[n].sys[sys_Web]) {
	alloc[n_alloc].cur = &(unit[n].web);
	strcpy(alloc[n_alloc++].desc, "Web");
	}

for (j = 0; j < type[unit[n].t].n_weapons; ++j) {
	if (unit[n].weapstat[j].num) {
		switch (type[unit[n].t].weapon[j].type) {
			case wp_Disruptor:
				sprintf(alloc[n_alloc].desc, "Charge Disruptor %s", type[unit[n].t].weapon[j].arcdesc);
				alloc[n_alloc].cur = &(unit[n].weapstat[j].power);
				alloc[n_alloc].inc = 2;
				alloc[n_alloc++].max = 2 * unit[n].weapstat[j].num;
				break;
			case wp_Photon:
				sprintf(alloc[n_alloc].desc, "Charge Photon torpedo %s",  type[unit[n].t].weapon[j].arcdesc);
				alloc[n_alloc].cur = &(unit[n].weapstat[j].power);
				alloc[n_alloc].inc = 2;
				alloc[n_alloc++].max = 2 * unit[n].weapstat[j].num;
				break;
			case wp_Plasma:
				sprintf(alloc[n_alloc].desc, "Charge %s %s", plasma[type[unit[n].t].weapon[j].subtype].name, type[unit[n].t].weapon[j].arcdesc);
				alloc[n_alloc].cur = &(unit[n].weapstat[j].power);							alloc[n_alloc++].max = 2 * unit[n].weapstat[j].num;
			}
		}
	}

if (unit[n].pcap < unit[n].pcap_max) {
	strcpy(alloc[n_alloc].desc, "Charge phaser capacitors");
	alloc[n_alloc].cur = &pcap;
	alloc[n_alloc++].max = unit[n].pcap_max - unit[n].pcap;
	}

for (j = 0; j < n_alloc; ++j)
	*(alloc[j].cur) = 0;

init_menu(bdone, bdone_n);

MoreAlloc:
dirty = 1;
while (!done) {
	patfill(toolbar, metal, 0, 0);
	switch (draw_buttons()) {
		case 0:
			done = 1;
			break;
		case 1:
			for (j = 0; j < n_alloc; ++j)
				*(alloc[j].cur) = 0;
			pwr = max_pwr;
			dirty = 1;
			break;
		}
	if (mouse_left()) {
		if (mouse_x <= 700 && mouse_y > FONT_BUF && mouse_y <= FONT_BUF * (n_alloc + 1)) {
			i = mouse_y / FONT_BUF - 1;
			if (pwr) {
				if (alloc[i].inc) {
					if (*(alloc[i].cur) + alloc[i].inc <= alloc[i].max) {
						*(alloc[i].cur) += alloc[i].inc;
						pwr -= alloc[i].inc;
						}
					else {
						pwr -= alloc[i].max - *(alloc[i].cur);
						*(alloc[i].cur) = alloc[i].max;
						}
					}
				else if (*(alloc[i].cur) < alloc[i].max || !(alloc[i].max))  {
					++*(alloc[i].cur);
					--pwr;
					}
				dirty = 1;
				}
			}
		}
	if (mouse_right()) {
		if (mouse_x <= 700 && mouse_y > FONT_BUF && mouse_y <= FONT_BUF * (n_alloc + 1)) {
			i = mouse_y / FONT_BUF - 1;
			if (*(alloc[i].cur)) {
				if (alloc[i].inc) {
					if (*(alloc[i].cur) - alloc[i].inc >= 0) {
						*(alloc[i].cur) -= alloc[i].inc;
						pwr += alloc[i].inc;
						}
					else {
						pwr += *(alloc[i].cur);
						*(alloc[i].cur) = 0;
						}
					}
				else {
					--*(alloc[i].cur);
					++pwr;
					}
				dirty = 1;
				}
			}
		}
	if (dirty) {
		draw_status();
		clear_to_color(map, white);
		rect(map, 0, 0, 700, FONT_BUF, black);
		textout(map, font, "System", 1, 1, blue);
		textout(map, font, "Current", 580, 1, red);
		textout(map, font, "Max", 640, 1, red);
		vline(map, 580, 0, FONT_BUF, black);
		vline(map, 640, 0, FONT_BUF, black);
		for (j = 0; j < n_alloc; ++j) {
			rect(map, 0, (j+1) * FONT_BUF, 700, (j+2) * FONT_BUF, black);
			textout(map, font, alloc[j].desc, 1 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			textout(map, font, itoa(*(alloc[j].cur), temp, 10), 580 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			textout(map, font, itoa(alloc[j].max, temp, 10), 640 + FONT_PAD, (j+1) * FONT_BUF + FONT_PAD, black);
			vline(map, 580, (j+1) * FONT_PAD, (j+2) * FONT_BUF, black);
			vline(map, 640, (j+1) * FONT_PAD, (j+2) * FONT_BUF, black);
			}
		textprintf(map, font, FONT_PAD, 500 - FONT_BUF + FONT_PAD, red, "Power: %d", pwr);

		vsync();
		show_mouse(NULL);
		blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		show_mouse(screen);
		dirty = 0;
		}
	}

if (!ls)
	if (alert("Are you sure you don't want to allocate power to life support?", "All crew will perish", NULL, "Yes", "No", 0, 0) == 2) {
		done = 0;
		goto MoreAlloc;
		}
	else {
		unit[n].sys[sys_Crew] = 0;
		unit[n].sys[sys_BoardP] = 0;
		}

unit[n].gen_reinforce /= 2;
unit[n].pcap += pcap;
for (j = 0; j < type[unit[n].t].n_weapons; ++j) {
	switch (type[unit[n].t].weapon[j].type) {
		case wp_Photon:
			unit[n].weapstat[j].armed = unit[n].weapstat[j].power / 2;
			break;
		case wp_Disruptor:
			unit[n].weapstat[j].armed = unit[n].weapstat[j].power / 2;
		}
	}
n_buttons = 0;
dirty = 1;

}

void check_status() {

if (mouse_x >= 670 && mouse_x <= 689 && mouse_left()) {
	if (mouse_y >= 511 && mouse_y <= 526) {
		if (logw) {
			--logw;
			dirty = 1;
			}
		}
	else if (mouse_y >= 566 && mouse_y <= 581) {
		if (logw < logc) {
			++logw;
			dirty = 1;
			}
		}
	}

}

void draw_status() {

int j;

patfill(status, metal, 0, 0);
rectfill(status, FONT_BUF, FONT_PAD + FONT_BUF, 700 - FONT_PAD - FONT_BUF, 100 - FONT_BUF * 2 + FONT_PAD, black);
rectfill(status, 670, 11, 689, 81, red);
rectfill(status, 670, 11, 689, 26, green);
rectfill(status, 670, 66, 689, 81, green);
for (j = logw; j < logw + LOG_ROWS && j < MAX_LOG; ++j)
	textout(status, font, logs[j], FONT_BUF + FONT_PAD, FONT_BUF * (j-logw+1) + FONT_PAD, white);

}

void draw_map() {

draw_status();
textprintf(status, font, FONT_PAD, FONT_PAD, blue, "Turn: %d  Impulse: %d", turn, imp);
if (dirty) {
	vsync();
	show_mouse(NULL);
	blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	show_mouse(screen);
	dirty = 0;
	}

}

void draw_units() {

int n;

patfill(map, bg, xw, yw);
for (n = 0; n < n_units; ++n)
	rotate_sprite(map, type[unit[n].t].icon, unit[n].x -type[unit[n].t].icon->w / 2 - xw, unit[n].y -type[unit[n].t].icon->h / 2 - yw, unit[n].r);

}

void dmg_shield(int a, int t, int s, int d) {

unsigned short sysdmg[N_SYS+4], weapdmg[type[unit[t].t].n_weapons];
char lock[N_SYS+4], wc[MAX_WEAPONS], nwc, temp[BS], temp2[BS];
int j, k, x, y, r, v, crew = 0, bparty = 0;

if (unit[t].shields) {
	if (d && unit[t].gen_reinforce) {
		if (d >= unit[t].gen_reinforce) {
			sprintf(temp, "%d points of damage stopped by general reinforcement", unit[t].gen_reinforce);
			write_log(temp);
			d -= unit[t].gen_reinforce;
			unit[t].gen_reinforce = 0;
			}
		else if (unit[t].gen_reinforce) {
			sprintf(temp, "%d points of damage stopped by general reinforcement", d);
			write_log(temp);
			unit[t].gen_reinforce -= d;
			d = 0;
			}
		}
	if (d && unit[t].reinforce[s]) {
		if (d >= unit[t].reinforce[s]) {
			sprintf(temp, "%d points of damage stopped by specific reinforcement", unit[t].reinforce[s]);
			write_log(temp);
			d -= unit[t].reinforce[s];
			unit[t].reinforce[s] = 0;
			}
		else if (unit[t].reinforce[s]) {
			sprintf(temp, "%d points of damage stopped by specific reinforcement", d);
			write_log(temp);
			unit[t].reinforce[s] -= d;
			d = 0;
			}
		}
	if (unit[t].sys[s]) {
		if (unit[t].sys[s] >= d) {
			write_log("Shield absorbs all damage");
			unit[t].sys[s] -= d;
			return;
			}
		else {
			sprintf(temp, "Shield absorbs %d damage", unit[t].sys[s]);
			write_log(temp);
			d -= unit[t].sys[s];
			unit[t].sys[s] = 0;
			}
		}
	}

bzero(sysdmg, sizeof(short) * (N_SYS+4));
bzero(weapdmg, sizeof(short) * type[unit[t].t].n_weapons);
bzero(lock, sizeof(char) * (N_SYS+4));

for (j = 0; j < d; ++j) {
	x = -1;
	y = rnd(6) + rnd(6);
	do {
		r = dmgalloc[y][++x];
		if (lock[r])
			v = 0;
		else if (r < 0) {
			switch (r) {
				case sys_Sensor:
					if (v = type[unit[t].t].n_sensor - unit[t].sensor)
						++(unit[t].sensor);
					break;
				case sys_Scanner:
					if (v = type[unit[t].t].n_scanner - unit[t].scanner)
						++(unit[t].scanner);
					break;
				case sys_DamCon:
					if (v = type[unit[t].t].n_damcon - unit[t].damcon)
						++unit[t].damcon;
					break;
				}
			}
		else if (r < 6) {
			nwc = 0;
			for (k = 0; k < type[unit[t].t].n_weapons; ++k)
				if (unit[t].weapstat[k].num && (r == wp_Any || type[unit[t].t].weapon[k].type == r) && check_arc(t, a, type[unit[t].t].weapon[k].min, type[unit[t].t].weapon[k].max))
					wc[nwc++] = k;
			v = nwc;
			}
		else {
			v = unit[t].sys[r];
			}
		} while (!v);
	if (0 <= r && r < 6) {
		++(weapdmg[wc[nwc = rnd(nwc)]]);
		--(unit[t].weapstat[wc[nwc]].num);
		}
	else {
		++(sysdmg[r]);
		--(unit[t].sys[r]);
		}
	for (k = 0; k < sizeof(lockloc); ++k)
		if (y == lockloc[k][0] && x == lockloc[k][1])
			lock[r] = 1;
	}

if (sysdmg[sys_Sensor]) {
	sprintf(temp, "%d damage scored on Sensors", sysdmg[sys_Sensor]);
	write_log(temp);
	}
if (sysdmg[sys_Scanner]) {
	sprintf(temp, "%d damage scored on Scanners", sysdmg[sys_Scanner]);
	write_log(temp);
	}
if (sysdmg[sys_DamCon]) {
	sprintf(temp, "%d damage scored on Damage control", sysdmg[sys_DamCon]);
	write_log(temp);
	}

for (j = 6; j < N_SYS; ++j) {
	if (sysdmg[j]) {
		sprintf(temp, "%d damage scored on %s", sysdmg[j], sysname[j]);
		temp[strlen(temp)-1] = '\0';
		write_log(temp);
		}
	}
for (j = 0; j < type[unit[t].t].n_weapons; ++j) {
	if (weapdmg[j]) {
		sprintf(temp, "%d damage scored on %s", weapdmg[j], weapdesc(temp2, &(type[unit[t].t].weapon[j])));
		write_log(temp);
		}
	}

if (unit[t].sys[sys_Crew]) {
	crew = (unit[t].crewd += d) / 10;
	unit[t].crewd %= 10;
	}
if (unit[t].sys[sys_BoardP]) {
	bparty = (unit[t].bpartyd += d) / 20;
	unit[t].bpartyd %= 20;
	}

if (crew == 1) {
	write_log("1 crew unit killed");
	--(unit[t].sys[sys_Crew]);
	}
else if (crew) {
	sprintf(temp, "%d crew units killed", crew);
	write_log(temp);
	}

if (bparty == 1) {
	write_log("1 boarding party killed");
	--(unit[t].sys[sys_BoardP]);
	}
else if (bparty) {
	sprintf(temp, "%d boarding parties killed", bparty);
	write_log(temp);
	}

}

char check_arc(int a, int t, fixed min, fixed max) {

fixed angle = fadd(fatan(itofix((unit[a].y - unit[t].y) / (unit[t].x - unit[a].x))), fsub(itofix(43), unit[a].r));
if (unit[a].x > unit[t].x && unit[a].y > unit[t].y)
	angle = fsub(itofix(128), angle);
else if (unit[a].x > unit[t].x && unit[a].y < unit[t].y)
	angle = fadd(itofix(128), angle);
else if (unit[a].x < unit[t].x && unit[a].y < unit[t].y)
	angle = fsub(itofix(256), angle);
angle &= itofix(255);

if (min > max) {
	if (angle >= min || angle <= max)
		return 1;
	}
else {
	if (angle >= min && angle <= max)
		return 1;
	}
return 0;

}

int get_shield(int a, int t) {

fixed angle = fsub(fatan(itofix((unit[a].y - unit[t].y) / (unit[t].x - unit[a].x))), unit[t].r);
if (unit[a].x > unit[t].x && unit[a].y > unit[t].y)
	angle = fsub(itofix(256), angle);
else if (unit[a].x > unit[t].x && unit[a].y < unit[t].y)
	angle = fadd(itofix(128), angle);
else if (unit[a].x < unit[t].x && unit[a].y < unit[t].y)
	angle = fsub(itofix(128), angle);
angle &= itofix(255);

if (angle <= itofix(22) || angle >= itofix(234))
	return 0;
else if (angle <= itofix(65))
	return 5;
else if (angle <= itofix(108))
	return 4;
else if (angle <= itofix(151))
	return 3;
else if (angle <= itofix(194))
	return 2;
else
	return 1;

}

void make_bweapons(int n) {

int j;

bweapons_n = 0;
for (j = 0; j < type[unit[n].t].n_weapons; ++j) {
	if (unit[n].weapstat[j].num && unit[n].weapstat[j].used < unit[n].weapstat[j].num) {
		switch (type[unit[n].t].weapon[j].type) {
			default:
				blit(icon_weapons, bweapons[bweapons_n].icon, 0, 0, 0, 0, 64, 64);
			}
		textout_centre(bweapons[bweapons_n].icon, font, type[unit[n].t].weapon[j].arcdesc, 32, 64 - FONT_BUF, blue);
		bweapons[bweapons_n++].tag = j;
		}
	}
blit(icon_done, bweapons[bweapons_n].icon, 0, 0, 0, 0, 64, 64);
bweapons[bweapons_n++].tag = 100;

}

BITMAP *_line_sprite;

void _draw_sprite(BITMAP *bmp, int x, int y, int c) {
if (++acnt == PROJ_SPEED) {
	draw_units();
	draw_sprite(bmp, _line_sprite, x - _line_sprite->w/2, y - _line_sprite->h/2);
	dirty = 1;
	draw_map();
	acnt = 0;
	}
}

void fire_weapon(int a, int t, int n) {

char temp[BS], temp2[BS];
int j, k, xinc, yinc, dmg, dist;
int at_x = unit[a].x - xw, at_y = unit[a].y - yw, t_x = unit[t].x - xw, t_y = unit[t].y - yw;

dist = get_dist(a, t);

draw_map();

delay(anim_speed);
switch (type[unit[a].t].weapon[n].type) {
	case wp_Phaser:
		xinc = (t_x - at_x) / LINE_INC;
		yinc = (t_y - at_y) / LINE_INC;
		_radius = phaser[type[unit[a].t].weapon[n].subtype].size;
		for (j = at_x, k = at_y; (xinc < 0 ? j >= t_x : j <= t_x) && !key[KEY_ESC]; j += xinc, k += yinc) {
			check_status();
			draw_units();
			do_line(map, at_x, at_y, j, k, red, _circle);
			dirty = 1;
			draw_map();
			delay(anim_speed);
			}
		for (j = at_x, k = at_y; (xinc < 0 ? j >= t_x : j <= t_x) && !key[KEY_ESC]; j += xinc, k += yinc) {
			check_status();
			draw_units();
			do_line(map, t_x, t_y, j, k, red, _circle);
			dirty = 1;
			draw_map();
			delay(anim_speed);
			}
		dmg = get_range(phaser[type[unit[a].t].weapon[n].subtype].range[rnd(6)], dist);
		sprintf(temp, "%s scores %d damage on %s shield #%d with %s", unit[a].name, dmg, unit[t].name, get_shield(a, t)+1, weapdesc(temp2, &(type[unit[a].t].weapon[n])));
		write_log(temp);
		dmg_shield(a, t, get_shield(a, t), dmg);
		break;
	case wp_Disruptor:
		xinc = (t_x - at_x) / LINE_INC;
		yinc = (t_y - at_y) / LINE_INC;
		_radius = 3;
		for (j = at_x, k = at_y; (xinc < 0 ? j >= t_x : j <= t_x) && !key[KEY_ESC]; j += xinc, k += yinc) {
			check_status();
			draw_units();
			do_line(map, at_x, at_y, j, k, green, _circle);
			dirty = 1;
			draw_map();
			delay(anim_speed);
			}
		for (j = at_x, k = at_y; (xinc < 0 ? j >= t_x : j <= t_x) && !key[KEY_ESC]; j += xinc, k += yinc) {
			check_status();
			draw_units();
			do_line(map, t_x, t_y, j, k, green, _circle);
			dirty = 1;
			draw_map();
			delay(anim_speed);
			}
		if (rnd(6) < get_range(disrupt, dist)) {
			dmg = get_range(ddamage, dist);
			sprintf(temp, "%s scores %d damage on %s shield #%d with %s", unit[a].name, dmg, unit[t].name, get_shield(a, t)+1, weapdesc(temp2, &(type[unit[a].t].weapon[n])));
			write_log(temp);
			dmg_shield(a, t, get_shield(a, t), dmg);
			}
		else {
			sprintf(temp, "%s misses %s with %s", unit[a].name, unit[t].name, weapdesc(temp2, &(type[unit[a].t].weapon[n])));
			write_log(temp);
			}
		break;
	case wp_Photon:
		xinc = (t_x - at_x) / PROJ_SPEED;
		yinc = (t_y - at_y) / PROJ_SPEED;
		for (j = at_x, k = at_y; (xinc < 0 ? j >= t_x : j <= t_x) && !key[KEY_ESC]; j += xinc, k += yinc) {
			check_status();
			draw_units();
			draw_sprite(map, icon_photon, j, k);
			dirty = 1;
			draw_map();
			}
		if (rnd(6) < get_range(photon, dist)) {
			dmg = 8;
			sprintf(temp, "%s scores %d damage on %s shield #%d with %s", unit[a].name, dmg, unit[t].name, get_shield(a, t)+1, weapdesc(temp2, &(type[unit[a].t].weapon[n])));
			write_log(temp);
			dmg_shield(a, t, get_shield(a, t), 8);
			}
		else {
			sprintf(temp, "%s misses %s with %s", unit[a].name, unit[t].name, weapdesc(temp2, &(type[unit[a].t].weapon[n])));
			write_log(temp);
			}
	}
draw_units();
dirty = 1;
draw_map();
		
}

void aim_weapon(int n, int w) {

int j, d, n_targs = 0;
short *targ = unit[n].weapstat[w].targ, *pwr = NULL;
int cstart = unit[n].weapstat[w].armed - unit[n].weapstat[w].used, count = cstart;

switch (type[unit[n].t].weapon[w].type) {
	case wp_Phaser:
		pwr = &(unit[n].pcap);
		break;
	}

init_menu(bdone, bdone_n);
while (d = draw_buttons()) {
	check_status();
	if (d == 1) {
		bzero(targ, sizeof(short) * MAX_UNITS);
		count = cstart;
		}
	draw_units();
	circle(map, unit[n].x - xw, unit[n].y - yw, type[unit[n].t].icon->w > type[unit[n].t].icon->h ? type[unit[n].t].icon->w/2 + 10 : type[unit[n].t].icon->h/2 + 10, red);
	if (pwr)
		textprintf(map, font, FONT_PAD, FONT_PAD, red, "Count: %d/%d  Power: %d", count, cstart, *pwr);
	else
		textprintf(map, font, FONT_PAD, FONT_PAD, red, "Count: %d/%d", count, cstart);
	for (j = 0; j < n_units; ++j) {
		if (targ[j])
			textprintf(map, font, unit[j].x - type[unit[j].t].icon->w/2, unit[j].y - type[unit[j].t].icon->h/2, red, "%d", targ[j]);
		if (j != n && check_arc(n, j, type[unit[n].t].weapon[w].min, type[unit[n].t].weapon[w].max))
			circle(map, unit[j].x - xw, unit[j].y - yw, type[unit[j].t].icon->w > type[unit[j].t].icon->h ? type[unit[j].t].icon->w/2 + 10 : type[unit[j].t].icon->h/2 + 10, green);
		}
	draw_map();
	if (mouse_left() && count && (*pwr || !pwr))
		for (j = 0; j < n_units; ++j)
			if (j != n && mouse_x >= unit[j].x - type[unit[j].t].icon->w/2 && mouse_x <= unit[j].x + type[unit[j].t].icon->w/2 && mouse_y >= unit[j].y - type[unit[j].t].icon->h/2 && mouse_y <= unit[j].y + type[unit[j].t].icon->h/2 && check_arc(n, j, type[unit[n].t].weapon[w].min, type[unit[n].t].weapon[w].max)) {
				if (pwr) --*pwr;
				--count;
				++targ[j];
				dirty = 1;
				}
	if (mouse_right())
		for (j = 0; j < n_units; ++j)
			if (j != n && mouse_x >= unit[j].x - type[unit[j].t].icon->w/2 && mouse_x <= unit[j].x + type[unit[j].t].icon->w/2 && mouse_y >= unit[j].y - type[unit[j].t].icon->h/2 && mouse_y <= unit[j].y + type[unit[j].t].icon->h/2 && targ[j]) {
				if (pwr) ++*pwr;
				++count;
				--targ[j];
				dirty = 1;
				}
	}

unit[n].weapstat[w].used += cstart - count;
dirty = 1;

}

void do_scenario() {

int j, k, n, d, n1, n2;
fixed rc;
char temp[BS];

msgbox("HI");

n_types = 2;
n_units = 2;
#ifdef AT
	load_type(&(type[0]), "#shp_fdd");
	load_type(&(type[1]), "#shp_kf5");
#else
	load_type(&(type[0]), "fdd.shp");
	load_type(&(type[1]), "kf5.shp");
#endif
bzero(&(unit[0]), sizeof(unitt) * 2);
type[0].icon = (BITMAP *)df[df_fca].dat;
type[1].icon = (BITMAP *)df[df_kf5].dat;
strcpy(unit[0].name, "USS Enterprise");
unit[0].t = 0;
unit[0].x = 350;
unit[0].y = 250;
unit[0].r = itofix(127);
unit[0].con = 1;
strcpy(unit[1].name, "IKF Goat");
unit[1].t = 1;
unit[1].x = 100;
unit[1].y = 200;
unit[1].r = 0;
unit[1].con = 1;
turn = 0;

write_log("Beginning scenario");
time(&now);
sprintf(temp, "Time is %s", asctime(localtime(&now)));
write_log(temp);

msgbox("Moocow ho-down");

for (j = 0; j < n_units; ++j) {
	for (k = 0; k < N_SYS; ++k)
		unit[j].sys[k] = type[unit[j].t].sys[k];
	for (k = 0; k < type[unit[j].t].n_weapons; ++k) {
		unit[j].weapstat[k].num = type[unit[j].t].weapon[k].num;
		unit[j].weapstat[k].used = unit[j].weapstat[k].num;
		if (type[unit[j].t].weapon[k].type == wp_Phaser)
			unit[j].pcap_max += phaser[type[unit[j].t].weapon[k].subtype].cost * unit[j].weapstat[k].num;
		}
	}

quit = 0;
turn = 0;
while (!key[KEY_ESC]) {
	write_log(NULL);
	sprintf(temp, "-- Turn %d --", ++turn);
	write_log(temp);
	for (j = 0; j < n_units; ++j) {
		if (!unit[j].sys[sys_Excess]) continue;
		unit[j].skip = 0;
		for (k = 0; k < type[unit[j].t].n_weapons; ++k) {
			if (type[unit[j].t].weapon[k].type == wp_Phaser)
				unit[j].weapstat[k].armed = unit[j].weapstat[k].num;
			else
				unit[j].weapstat[k].armed = 0;
			}
		if (unit[j].con) {
			allocate_energy(j);
			unit[j].speed = unit[j].move / type[unit[j].t].mcost;
			unit[j].ppt = unit[j].speed / 2;
			unit[j].xs = fixtoi(fmul(fcos(unit[j].r), itofix(unit[j].ppt)));
			unit[j].ys = fixtoi(fmul(fsin(unit[j].r), itofix(unit[j].ppt)));
			unit[j].tmode = get_range(turnm[type[unit[j].t].turn_mode - 'A'], unit[j].speed);
			}
		for (k = 0; k < type[unit[j].t].n_weapons; ++k) {
			unit[j].weapstat[k].used = 0;
			}
		}
	for (imp = 1; imp <= 32; ++imp) {
		sprintf(temp, "Impulse %d:", imp);
		write_log(temp);
		for (j = 0; j < n_units; ++j) {
			if (!unit[j].sys[sys_Excess]) continue;
			for (k = 0; k < MAX_WEAPONS; ++k)
				bzero(unit[j].weapstat[k].targ, sizeof(short) * MAX_UNITS);
			++(unit[j].last_turn);
			if (unit[j].con && !unit[j].skip) {
				center_map(unit[j].x, unit[j].y);
Reconsider:			bturn_n = 2;
				if (unit[j].fcontrol) {
					bturn[bturn_n].icon = icon_weapons;
					bturn[bturn_n++].tag = 1;
					}
				if (unit[j].last_turn >= unit[j].tmode) {
					bturn[bturn_n].icon = icon_turn;
					bturn[bturn_n++].tag = 2;
					}
				bturn[bturn_n].icon = icon_done;
				bturn[bturn_n++].tag = 3;
				bturn[bturn_n].icon = icon_skip;
				bturn[bturn_n++].tag = 5;
				init_menu(bturn, bturn_n);
				while ((d = draw_buttons()) != 3 && !unit[j].skip) {
					check_status();
					check_scroll();
					switch (d) {
						case 0:
							init_menu(bgame, bgame_n);
							while (d = draw_buttons()) {
								draw_map();
								switch (d) {
								case 1:
									if (alert("Are you sure you want to abort the scenario?", NULL, NULL, "Yes", "No", 0, 0) == 1)
										return;
									}
								}
							init_menu(bturn, bturn_n);
							break;
						case 1:
							make_bweapons(j);
							init_menu(bweapons, bweapons_n);
							while ((d = draw_buttons()) != 100 && !key[KEY_ESC]) {
								draw_map();
								if (d > -1) {
									aim_weapon(j, d);
									init_menu(bweapons, bweapons_n);
									draw_units();
									circle(map, unit[j].x - xw, unit[j].y - yw, type[unit[j].t].icon->w > type[unit[j].t].icon->h ? type[unit[j].t].icon->w/2 + 10 : type[unit[j].t].icon->h/2 + 10, red);
									}
								}
							init_menu(bturn, bturn_n);
							dirty = 1;
							break;
						case 2:
							rc = 0;
							dirty = 1;
							init_menu(bdone, bdone_n);
							while (draw_buttons()) {
								patfill(display, bg, 0, 0);
								rotate_sprite(display, type[unit[j].t].icon, 50 - type[unit[j].t].icon->w / 2, 50 - type[unit[j].t].icon->h / 2, fadd(unit[j].r, rc));
								draw_map();
								if (key[KEY_RIGHT]) {
									rc = fadd(rc, itofix(TURN_INC));
									if (fixtoi(rc) > TURN_MAX) rc = itofix(TURN_MAX);
									dirty = 1;
									}
								if (key[KEY_LEFT]) {
									rc = fsub(rc, itofix(TURN_INC));
									if (fixtoi(rc) < -TURN_MAX) rc = itofix(-TURN_MAX);
									dirty = 1;
									}
								}
							unit[j].r = itofix(fixtoi(fadd(unit[j].r, rc)) & 255);
							unit[j].xs = fixtof(fcos(unit[j].r)) *  unit[j].ppt;
							unit[j].ys = fixtof(fsin(unit[j].r)) * unit[j].ppt;
							unit[j].last_turn = 0;
							blit(disp_bmp, display, 0, 0, 0, 0, disp_bmp->w, disp_bmp->h);
							goto Reconsider;
							break;
						case 4:
							show_status(&(unit[j]));
							init_menu(bturn, bturn_n);
							break;
						case 5:
							unit[j].skip = 1;
						}
					if (dirty) {
						draw_units();
						circle(map, unit[j].x - xw, unit[j].y - yw, type[unit[j].t].icon->w > type[unit[j].t].icon->h ? type[unit[j].t].icon->w/2 + 10 : type[unit[j].t].icon->h/2 + 10, red);
						draw_map();
						}
					if (key[KEY_ESC]) return;
					}
				dirty = 1;
				draw_units();
				draw_map();
				}
			}
		for (j = 0; j < n_units; ++j) {
			if (!unit[j].sys[sys_Excess]) continue;
			unit[j].x += unit[j].xs;
			unit[j].y += unit[j].ys;
			center_map(unit[j].x, unit[j].y);
			for (k = 0; k < type[unit[j].t].n_weapons; ++k)
				for (n = 0; n < n_units; ++n)
					for (n1 = 0; n1 < unit[j].weapstat[k].targ[n]; ++n1)
						fire_weapon(j, n, k);
			}
		for (j = 0; j < n_units; ++j) {
			if (!unit[j].sys[sys_Excess] && unit[j].x >= 0) {
				sprintf(temp, "%s destroyed!", unit[j].name);
				write_log(temp);
				unit[j].x = -1000;
				}
			else if (!unit[j].sys[sys_Crew] && unit[j].con) {
				sprintf(temp, "The crew of %s have perished! It is now a ghost ship.", unit[j].name);
				write_log(temp);
				unit[j].con = 0;
				}
			}
		dirty = 1;
		blit(disp_bmp, display, 0, 0, 0, 0, disp_bmp->w, disp_bmp->h);
		draw_units();
		draw_map();
		}
	}

}

void hsegv(int n) {
signal(SIGSEGV, SIG_DFL);
msgbox("Fatal error: Segmentation fault");
exit(1);
}
void hfpe(int n) {
signal(SIGFPE, SIG_DFL);
msgbox("Fatal error: Erroneous arithmetic");
exit(1);
}
void hill(int n) {
signal(SIGILL, SIG_DFL);
msgbox("Fatal error: Illegal operation");
exit(1);
}

void main() {

unsigned char path[BS], quit = 0;
typet tp;
int j;

allegro_init();
set_color_depth(16);
if (set_gfx_mode(GFX_AUTODETECT, 800, 600, 0, 0) < 0) {
	allegro_exit();
	puts("Error initializing 16-bit 800x600 display");
	puts(allegro_error);
	exit(1);
	}
if (install_timer() == -1) {
	allegro_exit();
	puts("Error installing timer support");
	puts(allegro_error);
	exit(1);
	}
if (install_mouse() == -1) {
	allegro_exit();
	puts("Error installing mouse support");
	puts(allegro_error);
	exit(1);
	}
if (install_keyboard() == -1) {
	allegro_exit();
	puts("Error installing keyboard support");
	puts(allegro_error);
	exit(1);
	}
if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) == -1)
	soundf = 0;

signal(SIGSEGV, hsegv);
signal(SIGFPE, hfpe);
signal(SIGILL, hill);

black = 0;
white = makecol16(255, 255, 255);
yellow = makecol16(255, 255, 0);
red = makecol16(255, 0, 0);
green = makecol16(0, 255, 0);
blue = makecol16(0, 0, 255);

init_bmp(screen);
clear(screen);
textout_centre(screen, font, "Loading....", SCREEN_W/2, SCREEN_H/2, blue);
#ifdef AT
	if (!(df = load_datafile("#"))) {
#else
	if (!(df = load_datafile("sfb.dat"))) {
#endif
	allegro_exit();
	puts("Unable to load sfb.dat");
	exit(1);
	}
buffer = create_bitmap(SCREEN_W, SCREEN_H);
init_bmp(buffer);
map = create_sub_bitmap(buffer, 0, 0, 700, 500);
init_bmp(map);
toolbar = create_sub_bitmap(buffer, 700, 0, 100, 500);
init_bmp(toolbar);
display = create_sub_bitmap(buffer, 700, 500, 100, 100);
init_bmp(display);
status = create_sub_bitmap(buffer, 0, 500, 700, 100);
init_bmp(status);
old = create_bitmap(SCREEN_W, SCREEN_H);
init_bmp(old);
show_mouse(screen);
text_mode(-1);
srand(time(0));

icon_done = (BITMAP *)df[df_done].dat;
icon_reset = (BITMAP *)df[df_reset].dat;
icon_tedit = (BITMAP *)df[df_tedit].dat;
icon_tnew = (BITMAP *)df[df_tnew].dat;
icon_game = (BITMAP *)df[df_game].dat;
icon_weapons = (BITMAP *)df[df_weapons].dat;
icon_play = (BITMAP *)df[df_play].dat;
icon_turn = (BITMAP *)df[df_turn].dat;
icon_photon = (BITMAP *)df[df_photon].dat;
icon_status = (BITMAP *)df[df_status].dat;
icon_skip = (BITMAP *)df[df_skip].dat;
icon_quit = (BITMAP *)df[df_quit].dat;
logo = (BITMAP *)df[df_logo].dat;

bdone[0].icon = icon_done;
bdone[0].tag = 0;
bdone[1].icon = icon_reset;
bdone[1].tag = 1;
bdone_n = 2;

bmain[0].icon = icon_play;
bmain[0].tag = 0;
bmain[1].icon = icon_tnew;
bmain[1].tag = 1;
bmain[2].icon = icon_tedit;
bmain[2].tag = 2;
bmain[3].icon = icon_quit;
bmain[3].tag = 3;
bmain_n = 4;

bturn[0].icon = icon_game;
bturn[0].tag = 0;
bturn[1].icon = icon_status;
bturn[1].tag = 4;
bturn_n = 2;

bgame[0].icon = icon_quit;
bgame[0].tag = 1;
bgame[1].icon = icon_done;
bgame[1].tag = 0;
bgame_n = 2;

for (j = 0; j < MAX_WEAPONS; ++j)
	bweapons[j].icon = create_bitmap(64, 64);

metal = (BITMAP *)df[df_metal].dat;
bg = (BITMAP *)df[df_bg].dat;
disp_bmp = (BITMAP *)df[df_sfb].dat;
bzero(logs, MAX_LOG * BS);

blit(logo, map, 0, 0, 0, 0, 700, 500);
init_menu(bmain, bmain_n);
write_log("Welcome to Star Fleet Battles");
write_log("Copyright Adam Chlipala 1998 (psion@tpu.org)");
write_log("Based on the game of the same name by Task Force Games");
while (!key[KEY_ESC] && !quit) {
	check_status();
	set_menu(bmain, bmain_n);
	patfill(toolbar, metal, 0, 0);
	switch (draw_buttons()) {
		case 0:
			do_scenario();
			init_menu(bmain, bmain_n);
			blit(logo, map, 0, 0, 0, 0, 700, 500);
			dirty = 1;
			break;
		case 1:
			path[0] = '\0';
			if (file_select("Save new type as", path, "SHP")) {
				bzero(&tp, sizeof(typet));
				edit_type(&tp);
				save_type(&tp, path);
				}
			dirty = 1;
			break;
		case 2:
			path[0] = '\0';
			if (file_select("Load type file", path, "SHP")) {
				load_type(&tp, path);
				edit_type(&tp);
				save_type(&tp, path);
				}
			dirty = 1;
			break;
		case 3:
			quit = 1;
		}
	if (dirty) {
		vsync();
		show_mouse(NULL);
		draw_status();
		blit(disp_bmp, display, 0, 0, 0, 0, disp_bmp->w, disp_bmp->h);
		blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		show_mouse(screen);
		dirty = 0;
		}
	}

unload_datafile(df);
allegro_exit();
puts("Thank you for playing");
puts("Questions? Comments? Contact Adam Chlipala at psion@tpu.org");

}
